﻿using Trinity.Technicals;
using Zeta.CommonBot.Profile;
using Zeta.TreeSharp;
using Zeta.XmlEngine;

namespace Trinity.XmlTags
{
    // TrinityMaxDeaths tells Trinity to handle deaths and exit game after X deaths
    [XmlElement("TrinityTrashPack")]
    public class TrinityTrashPack : ProfileBehavior
    {
        private bool m_IsDone = false;
        private int iSize;
		private int iRadius;

        public override bool IsDone
        {
            get { return m_IsDone; }
        }

        protected override Composite CreateBehavior()
        {
            return new Zeta.TreeSharp.Action(ret =>
            {
                //if (Size != Trinity.iSizeAllowed)
				if (Size != Trinity.iSizeAllowed || Radius != Trinity.iRadiusAllowed)
                {
                    Logger.Log(TrinityLogLevel.Normal, LogCategory.UserInformation, "Trash mob pack size and radius changed to ({0},{1})", Size, Radius); 
                }
				/*Settings.Combat.Misc.TrashPackSize = Size;
				Settings.Combat.Misc.TrashPackClusterRadius = Radius;*/
                Trinity.iSizeAllowed = Size;
				Trinity.iRadiusAllowed = Radius;
                /*if (Reset != null && Reset.ToLower() == "true")
                    Trinity.iDeathsThisRun = 0;*/
                m_IsDone = true;
            });
        }

        [XmlAttribute("size")]
        public int Size
        {
            get
            {
                return iSize;
            }
            set
            {
                iSize = value;
            }
        }

        [XmlAttribute("radius")]
        public int Radius
        {
            get
            {
                return iRadius;
            }
            set
            {
                iRadius = value;
            }
        }

        public override void ResetCachedDone()
        {
            m_IsDone = false;
            base.ResetCachedDone();
        }
    }
}
